## svxlink 14.08.1

=== src/CMakeLists.txt ===
##############################################################################
# SvxLink - A Multi Purpose Voice Services System for Ham Radio Use
# Copyright (C) 2003-2013 Tobias Blomberg / SM0SVX
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##############################################################################

##############################################################################
# Project setup
##############################################################################
cmake_minimum_required(VERSION 2.6)
project(svxlink C CXX)
#enable_testing()

# The path to the project global include directory
set(PROJECT_INCLUDE_DIR ${PROJECT_BINARY_DIR}/include)

# Where to put library files
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)

# Where to put executable files
set(RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)

# Add project local CMake module directory
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Optional parts
option(USE_QT "Build Qt applications and libs" ON)
option(BUILD_STATIC_LIBS "Build static libraries in addition to dynamic" OFF)

# The sample rate used internally in SvxLink
if(NOT DEFINED INTERNAL_SAMPLE_RATE)
  set(INTERNAL_SAMPLE_RATE 16000)
endif(NOT DEFINED INTERNAL_SAMPLE_RATE)
add_definitions(-DINTERNAL_SAMPLE_RATE=${INTERNAL_SAMPLE_RATE})

# Set up include directories
include_directories(
  ${PROJECT_INCLUDE_DIR}
  ${CMAKE_BINARY_DIR}
)

# Warnings should be enabled for GCC. Also turning off the NDEBUG flag
# since that remove asserts.
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_C_FLAGS
    "${CMAKE_C_FLAGS} -Wall -Wstrict-prototypes -Wpointer-arith")
  set(CMAKE_C_FLAGS_RELEASE "-O3")
  set(CMAKE_C_FLAGS_RELWITHDEBINFO "-O2 -g")

  set(CMAKE_CXX_FLAGS
    "${CMAKE_CXX_FLAGS} -Wall -Wpointer-arith")
  set(CMAKE_CXX_FLAGS_RELEASE "-O3")
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O2 -g")
endif()

# Set the default build type to Release
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
      "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif(NOT CMAKE_BUILD_TYPE)


##############################################################################
# Install targets properties setup
##############################################################################

# Where to install include files
if(NOT DEFINED INCLUDE_INSTALL_DIR)
  set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/include)
endif(NOT DEFINED INCLUDE_INSTALL_DIR)

# Where to install libraries
if(NOT DEFINED LIB_INSTALL_DIR)
  set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
endif(NOT DEFINED LIB_INSTALL_DIR)

# The config directory (normally /etc)
if(NOT DEFINED SYSCONF_INSTALL_DIR)
  set(SYSCONF_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/etc)
endif(NOT DEFINED SYSCONF_INSTALL_DIR)

# Architecture independent files directory (normally /usr/share)
if(NOT DEFINED SHARE_INSTALL_PREFIX)
  set(SHARE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}/share)
endif(NOT DEFINED SHARE_INSTALL_PREFIX)

# Local state directory (normally /var)
if(NOT DEFINED LOCAL_STATE_DIR)
  set(LOCAL_STATE_DIR ${CMAKE_INSTALL_PREFIX}/var)
endif(NOT DEFINED LOCAL_STATE_DIR)

# Where to install executables
if(NOT DEFINED BIN_INSTALL_DIR)
  set(BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin)
endif(NOT DEFINED BIN_INSTALL_DIR)

# Where to install manual pages
if(NOT DEFINED MAN_INSTALL_DIR)
  set(MAN_INSTALL_DIR ${SHARE_INSTALL_PREFIX}/man)
endif(NOT DEFINED MAN_INSTALL_DIR)

# Where to install documentation
if(NOT DEFINED DOC_INSTALL_DIR)
  set(DOC_INSTALL_DIR ${SHARE_INSTALL_PREFIX}/doc/svxlink)
endif(NOT DEFINED DOC_INSTALL_DIR)

# Where to install startup scripts
if(NOT DEFINED INIT_D_INSTALL_DIR)
  set(INIT_D_INSTALL_DIR ${SYSCONF_INSTALL_DIR}/init.d)
endif(NOT DEFINED INIT_D_INSTALL_DIR)

# Where to install SvxLink config files
if(NOT DEFINED SVX_SYSCONF_INSTALL_DIR)
  set(SVX_SYSCONF_INSTALL_DIR ${SYSCONF_INSTALL_DIR}/svxlink)
endif(NOT DEFINED SVX_SYSCONF_INSTALL_DIR)

# Where to install SvxLink spool files
if(NOT DEFINED SVX_SPOOL_INSTALL_DIR)
  set(SVX_SPOOL_INSTALL_DIR ${LOCAL_STATE_DIR}/spool/svxlink)
endif(NOT DEFINED SVX_SPOOL_INSTALL_DIR)

# Where to install SvxLink architecture independent files
if(NOT DEFINED SVX_SHARE_INSTALL_DIR)
  set(SVX_SHARE_INSTALL_DIR ${SHARE_INSTALL_PREFIX}/svxlink)
endif(NOT DEFINED SVX_SHARE_INSTALL_DIR)

# Where to install include files
if(NOT DEFINED SVX_INCLUDE_INSTALL_DIR)
  set(SVX_INCLUDE_INSTALL_DIR ${INCLUDE_INSTALL_DIR}/svxlink)
endif(NOT DEFINED SVX_INCLUDE_INSTALL_DIR)

# Where to install SvxLink modules
if(NOT DEFINED SVX_MODULE_INSTALL_DIR)
  set(SVX_MODULE_INSTALL_DIR ${LIB_INSTALL_DIR}/svxlink)
endif(NOT DEFINED SVX_MODULE_INSTALL_DIR)


##############################################################################
# Functions
##############################################################################

# Create an include file under the global include directory
function(expinc filename)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${filename}
    ${PROJECT_INCLUDE_DIR}/${filename}
    COPYONLY
    )
endfunction(expinc)

# Add a target for building a version/xyz.h file
#
#   add_version_target(name [depends_var])
#
# The name of the version variable should be VER_name and the versions file
# will be named versions/name.h.
# If depends_var is given it will be set to a list of dependencies that the
# target using the versions file should add to its dependency list.
function(add_version_target name)
  set(depends_var ${ARGV1})
  if(DEFINED depends_var)
    set(${depends_var} ${${depends_var}}
      "${PROJECT_INCLUDE_DIR}/version/${name}.h"
      PARENT_SCOPE
      )
  endif(DEFINED depends_var)

  if(VER_${name})
    set(VERSION ${VER_${name}})
  else(VER_${name})
    set(VERSION "?.?.?")
  endif(VER_${name})

  add_custom_command(
    OUTPUT ${PROJECT_INCLUDE_DIR}/version/${name}.h
    WORKING_DIRECTORY ${PROJECT_INCLUDE_DIR}
    COMMAND ${CMAKE_COMMAND} -DVER_NAME=${name} -DVER_VALUE=${VERSION} 
                     -P ${CMAKE_SOURCE_DIR}/cmake/create_version_include.cmake
    DEPENDS ${CMAKE_SOURCE_DIR}/versions
            ${CMAKE_SOURCE_DIR}/cmake/create_version_include.cmake
  )
endfunction(add_version_target)

# Read a versions file and set up CMake variables for each entry
function(read_versions_file filename)
  message(STATUS "Reading versions file...")
  file(STRINGS ${filename} versions REGEX .*=.*)
  foreach(version ${versions})
    string(REGEX REPLACE \(.*\)=\(.*\) "VER_\\1;\\2" version ${version})
    set(${version} PARENT_SCOPE)
    if(version MATCHES ^VER_LIB)
      list(GET version 0 varname)
      list(GET version 1 varvalue)
      string(REGEX MATCH [0-9]+\\.[0-9]+ ${varname}_SOVERSION ${varvalue})
      set(${varname}_SOVERSION ${${varname}_SOVERSION} PARENT_SCOPE)
    endif(version MATCHES ^VER_LIB)
  endforeach(version)
endfunction(read_versions_file)

# Create a post install target to change the owner of an installed file.
# If DO_INSTALL_CHOWN is set to YES, the owner will be changed during
# installation.
# If DO_INSTALL_CHOWN is unset, the DESTDIR environment variable will be
# examined. If it is set, no chown operations will be performed since we are
# probably not running as a user with administrative rights. If DESTDIR is
# unset, chown operations are performed.
function(install_chown filename owner)
  if(owner)
    set(chown_commands "
      set(CHOWN_TOOL ${CHOWN_TOOL})
      if(NOT CHOWN_TOOL)
        MESSAGE(FATAL_ERROR \"Unable to find the 'chown' utility\")
      endif(NOT CHOWN_TOOL)
      set(full_filename \"\$ENV{DESTDIR}${filename}\")
      message(STATUS \"Setting owner of \${full_filename} to ${owner}...\")
      execute_process(
        COMMAND ${CHOWN_TOOL} ${owner} \"\${full_filename}\"
        RESULT_VARIABLE cmd_result
        )
      if(NOT \${cmd_result} EQUAL 0)
        MESSAGE(FATAL_ERROR
          \"Error while changing owner of file \${full_filename}\"
          )
      endif(NOT \${cmd_result} EQUAL 0)
      ")
    if(DEFINED DO_INSTALL_CHOWN)
      if(DO_INSTALL_CHOWN)
        install(CODE "${chown_commands}")
      endif(DO_INSTALL_CHOWN)
    else(DEFINED DO_INSTALL_CHOWN)
      install(CODE "
        if(\"\$ENV{DESTDIR}\" STREQUAL \"\")
          ${chown_commands}
        endif(\"\$ENV{DESTDIR}\" STREQUAL \"\")
        ")
    endif(DEFINED DO_INSTALL_CHOWN)
  endif(owner)
endfunction(install_chown)

# Create the given directory during installation
#   install_mkdir(directory [owner])
function(install_mkdir dir)
  set(owner ${ARGV1})
  get_filename_component(parent ${dir} PATH)
  file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}${dir})
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}${dir} DESTINATION ${parent})
  install_chown(${dir} "${owner}")
endfunction(install_mkdir)

# Before installing the file, check if it exists. If it does, don't
# overwrite it.
#   install_if_not_exists(source_file destination_directory)
function(install_if_not_exists src dest)
  if(NOT IS_ABSOLUTE "${src}")
    set(src "${CMAKE_CURRENT_SOURCE_DIR}/${src}")
  endif()
  get_filename_component(src_name "${src}" NAME)
  if (NOT IS_ABSOLUTE "${dest}")
    set(dest "${CMAKE_INSTALL_PREFIX}/${dest}")
  endif()
  install(CODE "
    if(NOT EXISTS \"\$ENV{DESTDIR}${dest}/${src_name}\")
      #file(INSTALL \"${src}\" DESTINATION \"${dest}\")
      message(STATUS \"Installing: \$ENV{DESTDIR}${dest}/${src_name}\")
      execute_process(COMMAND \${CMAKE_COMMAND} -E copy \"${src}\"
                      \"\$ENV{DESTDIR}${dest}/${src_name}\"
                      RESULT_VARIABLE copy_result
                      ERROR_VARIABLE error_output)
      if(copy_result)
        message(FATAL_ERROR \${error_output})
      endif()
    else()
      message(STATUS \"Skipping  : \$ENV{DESTDIR}${dest}/${src_name}\")
    endif()
  ")
endfunction(install_if_not_exists)


##############################################################################
# Main execution starts here
##############################################################################

# Load the versions file and define version variables
read_versions_file(${PROJECT_SOURCE_DIR}/versions)

configure_file(${CMAKE_SOURCE_DIR}/config.h.in
  ${CMAKE_BINARY_DIR}/config.h
  @ONLY
  )

# Find the Sigc++ library
find_package(SIGC2 REQUIRED)
include_directories(${SIGC2_INCLUDE_DIRS})
add_definitions(${SIGC2_DEFINITIONS})
set(LIBS ${LIBS} ${SIGC2_LIBRARIES})

# Find the chown utility
include(FindCHOWN)

# Add directories to build
add_subdirectory(async)
add_subdirectory(misc)
add_subdirectory(echolib)
add_subdirectory(locationinfo)
add_subdirectory(svxlink)
if(USE_QT)
  add_subdirectory(qtel)
endif(USE_QT)
add_subdirectory(doc)

=== src/Makefile ===
#------------------------------------------------------------------------------
# Filename:             Makefile
# Author:               Tobias Blomberg
# Created:              1997-12-11
# Description:          This is the top-level makefile. Its
#			only purpose is to execute make in the
#			subdirectories in the correct order.
#			
# Targets:		all	  -- Make all
#			clean     -- Cleanup compiler generated files.
#			realclean -- Cleanup most generated files.
#			distclean -- Cleanup all generated files.
#			linecount -- Count the lines of source code.
#			tgz       -- Cleanup and create an archive. The
#				     archive is named 'current subdir'.tgz.
#			makefiles -- Create Makefiles in subdirectories.
#			install   -- Install project files.
#			uninstall -- Uninstall project files.
#     	      	      	rpm   	  -- Create RPMs
#     	      	      	rpmclean  -- Clean up RPMS build area.
#
# Executes:		echo	  -- Echo text to the screen.
#			find	  -- Find files.
#			awk	  -- Text processing tool.
#			tar	  -- Archiver tool.
#			bash	  -- Born Again Shell.
#			make	  -- Make.
#			rm	  -- Remove files.
#			ln	  -- Create softlinks in the filesystem.
#     	      	      	basename  -- Extract the filename part from a path
#     	      	      	rpm   	  -- Create RPM packages
#			perl      -- Text processing
#
#------------------------------------------------------------------------------


#
# Comment this out if you want to see what exactly is done by the
# make files. Used for debugging.
#
.SILENT:



###############################################################################
#
# Nothing to configure here...
#
###############################################################################

ifeq ($(OS),)
  -include ./makefile.root
  ifneq ($(ROOT),)
    -include $(ROOT)/makefile.cfg
    -include $(ROOT)/.config
  endif
endif

include makefile.dirs


# Reverse the order of the supplied directory list
REVDIRS 	= $$(echo $(SUBDIRS) | \
			awk '{ for(i=NF; i>0; i--) { printf $$i " "; } }')

# Name of the archive created with "make tgz"
ARCHIVENAME	= $$(basename $$(pwd)).tgz

# Used to get bold text in echo statements
BOLD		= "\033[1m"

# End bold text
NBOLD		= "\033[0m"

# Create softlink
MKSOFT		= ln -s

# Print directory
PRINT_DIR     	= \
      	      	print_dir() { \
		  $(ECHO) $(BOLD)-------------- $$1 --------------$(NBOLD); \
		}; print_dir

# Remove directory (must be empty)
RMDIR		= remove_dir() { \
		    $(ECHO) --- Removing directory $(BOLD)$$*$(NBOLD)...; \
		    rmdir $$*; \
		  }; remove_dir

RM = remove_file() { \
       local options files file; \
       while [ -n "$$1" ]; do \
         if echo $$1 | grep -qE "^-"; then \
           options="$$options $$1"; \
         else \
           files="$$files $$1"; \
         fi; \
         shift; \
       done; \
       for file in $$files; do \
         if [ -e "$$file" -o -L "$$file" ]; then \
           $(ECHO) --- Removing $(BOLD)$$file$(NBOLD)...; \
           rm $$options $$file; \
         fi \
       done; \
     }; remove_file


#
# all	    - Build all targets
# install   - Install applications, header files, libraries, plugins etc
# uninstall - Uninstall what the install target has installed
#
.PHONY:	all install uninstall release
all install uninstall release:	makefiles
ifeq ($(OS),)
	SUBDIRS="$(SUBDIRS)"; \
	for dir in $${SUBDIRS}; do \
	    if [ -d $$dir ]; then \
		$(PRINT_DIR) $(CURRENT_SUBDIR)$$dir ; \
		$(MAKE) CURRENT_SUBDIR="$(CURRENT_SUBDIR)$$dir/" -C $$dir $@; \
		ec=$$?; \
		if [ $$ec -ne 0 ]; then \
		  exit $$ec; \
		fi \
	    fi \
	done
else
	$(MAKE) -f Makefile.win32 vc
endif


#
# linecount - Count how many lines of .c .h and .cpp files.
#
.PHONY:	linecount
linecount:
ifeq ($(OS),)
	$(ECHO) -n $(BOLD)"Lines total sourcecode: "
	find . \( -name "*.c" -o -name "*.h" -o -name "*.cpp" \) \
		-exec wc {} \; | awk '{ sum += $$1 } END { printf sum }'
	$(ECHO) $(NBOLD)
endif


#
# clean - Remove files created during compilation (excluding dependency
#         information and cache files used in the makefile structure).
#
.PHONY:	clean
clean:	makefiles
ifeq ($(OS),)
	for dir in $(REVDIRS); do \
	    if [ -d $$dir ]; then \
		$(PRINT_DIR) $(CURRENT_SUBDIR)$$dir ; \
		$(MAKE) CURRENT_SUBDIR="$(CURRENT_SUBDIR)$$dir/" -C $$dir $@; \
	    fi \
	done
else
	$(MAKE) -f Makefile.win32 $@
endif


#
# rpmclean - Remove RPM related directories and files
#
.PHONY:	rpmclean
rpmclean:
ifeq ($(OS),)
	if [ -f makefile.inc ]; then \
	  if [ -n "$(RPM_DIR)" ]; then \
	    $(ECHO) --- Removing RPM related directories...; \
	    $(RM) -rf $(RPM_DIR)/RPMS $(RPM_DIR)/TMP_SPECS $(RPM_DIR)/BUILD \
	      	      $(RPM_DIR)/SRPMS $(RPM_DIR)/SOURCES; \
	  fi \
	fi
endif
	

#
# realclean - Remove everything created by the makefiles except the
#             softlinks.
#
.PHONY:	realclean
realclean:	rpmclean makefiles
ifeq ($(OS),)
	for dir in $(REVDIRS); do \
	    if [ -d $$dir ]; then \
		$(PRINT_DIR) $(CURRENT_SUBDIR)$$dir ; \
		$(MAKE) CURRENT_SUBDIR="$(CURRENT_SUBDIR)$$dir/" -C $$dir $@; \
	    fi \
	done
	$(RM) *~ $(ARCHIVENAME) .config
	if [ ! -r makefile.inc ]; then \
	  $(RM) makefile.root; \
	fi
else
	$(MAKE) -f Makefile.win32 $@
endif


#
# distclean - Remove everything created by the makefiles including
#             softlinks so that the source tree looks exactly like
#             when it was first unpacked.
#
.PHONY:	distclean
distclean:	realclean
ifeq ($(OS),)
	for file in $$(find . -type l -name Makefile); do \
	  $(RM) $$file; \
	done
	if [ -r makefile.inc ]; then \
	  if [ -d $(BIN) ] && [ -z "$$(ls -A $(BIN))" ]; then \
	    $(RMDIR) $(BIN); \
	  fi; \
	  if [ -d $(LIB) ] && [ -z "$$(ls -A $(LIB))" ]; then \
	    $(RMDIR) $(LIB); \
	  fi; \
	  if [ -d $(INC) ] && [ -z "$$(ls -A $(INC))" ]; then \
	    $(RMDIR) $(INC); \
	  fi \
	fi
else
	$(MAKE) -f Makefile.win32 $@
endif


#
# tgz - Create a tar-archive of the subdirectory
#
.PHONY:	tgz
tgz:	makefiles realclean
ifeq ($(OS),)
	export current_dir_name=$$(basename $$(pwd)); \
	export archive_name="$${current_dir_name}.tgz"; \
	$(ECHO) --- Creating archive $(BOLD)$${archive_name}$(NBOLD)...; \
	cd ..; \
	tar czf $${current_dir_name}/$${archive_name} \
		--exclude $${archive_name} $${current_dir_name}; \
	cd $${current_dir_name}
endif


#
# makefiles - Create the makefile structure (softlinks).
#
.PHONY:	makefiles
makefiles:
ifeq ($(OS),)
	if [ "$(ROOT)" = "." ]; then \
	  ROOT=..; \
	else \
	  ROOT=$(ROOT)/..; \
	fi; \
	SUBDIRS="$(SUBDIRS)"; \
	for dir in $${SUBDIRS}; do \
	  if [ -d $$dir -a ! -r $$dir/Makefile ]; then \
	    if [ -r $$dir/makefile.dirs ]; then \
	      ( \
	        cd $$dir; $(MKSOFT) $${ROOT}/Makefile; \
		$(MAKE) makefiles; \
	      ); \
	    else \
		( cd $$dir; $(MKSOFT) $${ROOT}/makefile.sub Makefile ); \
	    fi \
	  fi \
	done
endif


#
# rpm - Create RPMs
#
.PHONY: rpm
rpm:
ifeq ($(OS),)
	if [ -z "$(MADE_FROM_TOP)" -a ! -f makefile.inc ]; then \
	  $(ECHO) "*** This target must be made from the project top source" \
	  	  "directory!"; \
	  exit 1; \
	fi
	if [ -z "$(RPM_DIR)" ]; then \
	  $(ECHO) "*** Variable RPM_DIR not set in makefile.cfg!"; \
	  exit 1; \
	fi
	if [ ! -r $(ROOT)/versions ]; then \
	  $(ECHO) "*** ERROR: Version file missing: \"$(ROOT)/versions\"." \
	      	  "Aborting..."; \
	  exit 1; \
	fi
	if [ -f makefile.inc ]; then \
	  rm -f $(RPM_DIR)/TMP_SPECS/*; \
	fi
	SUBDIRS="$(SUBDIRS)"; \
	for dir in $${SUBDIRS}; do \
	    if [ -d $$dir ]; then \
		$(PRINT_DIR) $(CURRENT_SUBDIR)$$dir ; \
		$(MAKE) CURRENT_SUBDIR="$(CURRENT_SUBDIR)$$dir/" \
		     MADE_FROM_TOP=1 -C $$dir $@; \
	    fi \
	done
	if [ -f makefile.inc ]; then \
	  export HOME=$(RPM_DIR); \
	  echo %_topdir $(RPM_DIR) > $(RPM_DIR)/.rpmmacros; \
	  echo %_unpackaged_files_terminate_build 0 >> $(RPM_DIR)/.rpmmacros; \
	  rpmbuild -bb $(RPM_DIR)/TMP_SPECS/*; \
	  rm -rf /tmp/rpm-tmp-install; \
	fi
endif


#
# Create a cache file containing the relative path to the project root
#
makefile.root:
	( \
	  export WRITETO=$$(pwd); \
	  if [ -r makefile.inc ]; then \
	    ROOT="."; \
	  else \
	    ROOT=".."; \
	    cd ..; \
	    while [ ! -r makefile.inc ]; do \
	      cd ..; \
	      ROOT="$${ROOT}/.."; \
	    done; \
	  fi; \
	  echo "ROOT=$${ROOT}" > $${WRITETO}/$@; \
	  echo "export ROOT" >> $${WRITETO}/$@; \
	)


#
# Create the .config file if it does not exist
#
$(ROOT)/.config:	$(ROOT)/create_config.sh
	/bin/echo --- Creating $@...
	$(ROOT)/create_config.sh $@



#
# This file has not been truncated
#

=== src/doc/CMakeLists.txt ===
# Add an empty doc target. We'll add dependencies later
add_custom_target(doc)

# Add targets to generate API documentation with Doxygen if it's installed
find_package(Doxygen)
if(DOXYGEN_FOUND)
  configure_file(doxygen.echolib.in doxygen.echolib @ONLY)
  add_custom_target(echolib-doc
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/doxygen.echolib
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating EchoLib API documentation using Doxygen"
    VERBATIM
    )
  add_dependencies(doc echolib-doc)
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/echolib/html/
    DESTINATION ${DOC_INSTALL_DIR}/echolib
    OPTIONAL)

  configure_file(doxygen.async.in doxygen.async @ONLY)
  add_custom_target(async-doc
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/doxygen.async
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating Async API documentation using Doxygen"
    VERBATIM
    )
  add_dependencies(doc async-doc)
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/async/html/
    DESTINATION ${DOC_INSTALL_DIR}/async
    OPTIONAL)

  set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
    "echolib;async"
    )
endif(DOXYGEN_FOUND)

add_subdirectory(man)

=== src/echolib/CMakeLists.txt ===
# Find the GSM codec library and include directory
find_package(GSM REQUIRED)
include_directories(${GSM_INCLUDE_DIR})
set(LIBS ${LIBS} ${GSM_LIBRARY})

# Find Speex
find_package(Speex)
if(Speex_FOUND)
  if(Speex_VERSION_MAJOR)
    include_directories(${Speex_INCLUDE_DIRS})
    add_definitions(${Speex_DEFINITIONS})
    add_definitions("-DSPEEX_MAJOR=${Speex_VERSION_MAJOR}")
    set(LIBS ${LIBS} ${Speex_LIBRARIES})
  else()
    message(WARNING
      "Found Speex but version could not be resolved. "
      "Will proceed without Speex.")
  endif()
endif(Speex_FOUND)

set(LIBNAME echolib)

set(INSTALL_INC EchoLinkDirectory.h EchoLinkDispatcher.h EchoLinkQso.h
  EchoLinkStationData.h EchoLinkProxy.h)
set(EXPINC ${INSTALL_INC} rtp.h)

set(LIBSRC EchoLinkDirectory.cpp EchoLinkQso.cpp rtpacket.cpp
  EchoLinkDispatcher.cpp EchoLinkStationData.cpp EchoLinkProxy.cpp
  EchoLinkDirectoryCon.cpp md5.c)

set(LIBS ${LIBS} asynccore asyncaudio)

set(EXECUTABLES EchoLinkDispatcher_demo EchoLinkDirectory_demo
                EchoLinkQso_demo)

# Copy exported include files to the global include directory
foreach(incfile ${EXPINC})
  expinc(${incfile})
endforeach(incfile)

# Build a shared library and a static library if configured
add_library(${LIBNAME} SHARED ${LIBSRC})
set_target_properties(${LIBNAME} PROPERTIES VERSION ${VER_LIBECHOLIB}
  SOVERSION ${VER_LIBECHOLIB_SOVERSION})
target_link_libraries(${LIBNAME} ${LIBS})
if (BUILD_STATIC_LIBS)
  add_library(${LIBNAME}_static STATIC ${LIBSRC})
  set_target_properties(${LIBNAME}_static PROPERTIES OUTPUT_NAME ${LIBNAME})
  target_link_libraries(${LIBNAME}_static ${LIBS})
endif(BUILD_STATIC_LIBS)

# Find the popt library
find_package(Popt REQUIRED)
include_directories(${POPT_INCLUDE_DIRS})
add_definitions(${POPT_DEFINITIONS})

# Build applications
foreach(exe ${EXECUTABLES})
  add_executable(${exe} ${exe}.cpp)
  target_link_libraries(${exe} ${LIBS} echolib asynccpp asyncaudio asynccore)
endforeach(exe)

add_executable(echolib_test echolib_test.cpp EchoLinkQsoTest.cpp)
target_link_libraries(echolib_test ${LIBS} ${POPT_LIBRARIES} echolib asynccpp
                        asyncaudio asynccore)

# Install files
install(TARGETS ${LIBNAME} DESTINATION ${LIB_INSTALL_DIR})
if (BUILD_STATIC_LIBS)
  install(TARGETS ${LIBNAME}_static DESTINATION ${LIB_INSTALL_DIR})
endif(BUILD_STATIC_LIBS)
install(FILES ${INSTALL_INC} DESTINATION ${SVX_INCLUDE_INSTALL_DIR})

=== src/locationinfo/CMakeLists.txt ===
# The name of the library
set(LIBNAME locationinfo)

# Which include files to export to the global include directory
set(EXPINC LocationInfo.h AprsClient.h AprsTcpClient.h AprsUdpClient.h)

# What sources to compile for the library
set(LIBSRC LocationInfo.cpp AprsTcpClient.cpp AprsUdpClient.cpp)

# Which other libraries this library depends on
set(LIBS ${LIBS} asynccore)

# Copy exported include files to the global include directory
foreach(incfile ${EXPINC})
  expinc(${incfile})
endforeach(incfile)

# Add targets for version files
set(VERSION_DEPENDS)
add_version_target(SVXLINK VERSION_DEPENDS)

# Build only a static library
add_library(${LIBNAME} STATIC ${LIBSRC} ${VERSION_DEPENDS})
target_link_libraries(${LIBNAME} ${LIBS})

# Install targets
#install(TARGETS ${LIBNAME} DESTINATION ${LIB_INSTALL_DIR})

=== src/misc/CMakeLists.txt ===
set(EXPINC common.h)

# Copy exported include files to the global include directory
foreach(incfile ${EXPINC})
  expinc(${incfile})
endforeach(incfile)

# Install targets
install(FILES ${EXPINC} DESTINATION ${SVX_INCLUDE_INSTALL_DIR})

=== src/qtel/CMakeLists.txt ===
# The program name
set(PROG qtel)

# Program source
set(PRGSRC qtel.cpp MainWindow.cpp ComDialog.cpp Settings.cpp MsgHandler.cpp
	   Vox.cpp EchoLinkDirectoryModel.cpp)

# Header files that need to be run through moc
set(QTHEADERS MainWindow.h ComDialog.h MyMessageBox.h Vox.h
	      SettingsDialog.h EchoLinkDirectoryModel.h)

# Forms that need to be run through uic
set(FORMS MainWindowBase.ui ComDialogBase.ui SettingsDialogBase.ui)            

# Resource files
set(RESOURCES qtel.qrc)

# Libraries
set(LIBS ${LIBS} echolib asyncqt asyncaudio asynccore)

# Find the GSM codec library and include directory
find_package(GSM REQUIRED)
include_directories(${GSM_INCLUDE_DIR})
set(LIBS ${LIBS} ${GSM_LIBRARY})

# Find Qt4
find_package(Qt4 4.2 REQUIRED QtCore QtGui QtNetwork)
include(${QT_USE_FILE})
set(LIBS ${LIBS} ${QT_LIBRARIES})

# Generate targets for moc, uic and rcc
QT4_WRAP_CPP(QTHEADERS_MOC ${QTHEADERS})
QT4_WRAP_UI(FORMS_HEADERS ${FORMS})
QT4_ADD_RESOURCES(RESOURCES_RCC ${RESOURCES})

# We also need to add the current build directory to the include search path
# to find automatically generated h-files.
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# Add targets for version files
set(VERSION_DEPENDS)
string(TOUPPER ${PROG} PROG_VERNAME)
add_version_target(${PROG_VERNAME} VERSION_DEPENDS)

# Compile the application
add_executable(${PROG} ${PRGSRC} ${QTHEADERS_MOC} ${FORMS_HEADERS}
  ${RESOURCES_RCC} ${VERSION_DEPENDS}
  )
target_link_libraries(${PROG} ${LIBS})
set_target_properties(${PROG} PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY ${RUNTIME_OUTPUT_DIRECTORY}  
  )

# Install targets
install(TARGETS ${PROG} DESTINATION ${BIN_INSTALL_DIR})
install(FILES connect.raw DESTINATION ${SHARE_INSTALL_PREFIX}/qtel/sounds)
install(FILES qtel.desktop DESTINATION ${SHARE_INSTALL_PREFIX}/applications)
install(FILES images/link.xpm DESTINATION ${SHARE_INSTALL_PREFIX}/icons)

# Build the translations subdirectory
add_subdirectory(translations)

=== src/svxlink/CMakeLists.txt ===
include_directories(trx svxlink)

add_subdirectory(trx)
add_subdirectory(svxlink)
add_subdirectory(modules)
#add_subdirectory(scripts)
add_subdirectory(remotetrx)
add_subdirectory(siglevdetcal)

=== src/async/audio/CMakeLists.txt ===
option(USE_ALSA "Alsa audio support" ON)
option(USE_OSS "OSS audio support" ON)

# Find Speex
find_package(Speex)
if(Speex_FOUND)
  if(DEFINED Speex_VERSION_MAJOR)
    include_directories(${Speex_INCLUDE_DIRS})
    add_definitions(${Speex_DEFINITIONS})
    add_definitions("-DSPEEX_MAJOR=${Speex_VERSION_MAJOR}")
    set(LIBS ${LIBS} ${Speex_LIBRARIES})
  else()
    message(WARNING
      "Found Speex but version could not be resolved. "
      "Will proceed without Speex.")
  endif()
endif(Speex_FOUND)

# Find Opus
find_package(Opus)
if(Opus_FOUND)
  if(DEFINED Opus_VERSION_MAJOR)
    include_directories(${Opus_INCLUDE_DIRS})
    add_definitions(${Opus_DEFINITIONS})
    add_definitions("-DOPUS_MAJOR=${Opus_VERSION_MAJOR}")
    set(LIBS ${LIBS} ${Opus_LIBRARIES})
  else()
    message(WARNING
      "Found Opus but version could not be resolved. "
      "Will proceed without Opus.")
  endif()
endif(Opus_FOUND)

find_package(GSM REQUIRED)
include_directories(${GSM_INCLUDE_DIR})
set(LIBS ${LIBS} ${GSM_LIBRARY})

set(LIBNAME asyncaudio)

set(EXPINC AsyncAudioSource.h AsyncAudioSink.h AsyncAudioProcessor.h
           AsyncAudioClipper.h AsyncAudioCompressor.h
           AsyncAudioFilter.h AsyncSigCAudioSink.h  AsyncSigCAudioSource.h
           AsyncAudioIO.h AsyncAudioSplitter.h AsyncAudioDelayLine.h
           AsyncAudioValve.h AsyncAudioAmp.h AsyncAudioSelector.h
           AsyncAudioPassthrough.h AsyncAudioMixer.h AsyncAudioFifo.h
           AsyncAudioDebugger.h AsyncAudioPacer.h AsyncAudioReader.h
           AsyncAudioDecimator.h AsyncAudioInterpolator.h
           AsyncAudioStreamStateDetector.h AsyncAudioEncoder.h
           AsyncAudioDecoder.h AsyncAudioRecorder.h
           AsyncAudioJitterFifo.h AsyncAudioDeviceFactory.h
           AsyncAudioDevice.h)

set(LIBSRC AsyncAudioSource.cpp AsyncAudioSink.cpp
           AsyncAudioProcessor.cpp AsyncAudioCompressor.cpp
           AsyncAudioFilter.cpp fidlib.c AsyncAudioDevice.cpp
           AsyncAudioIO.cpp AsyncAudioSplitter.cpp
           AsyncAudioDelayLine.cpp AsyncAudioSelector.cpp
           AsyncAudioMixer.cpp AsyncAudioFifo.cpp AsyncAudioPacer.cpp
           AsyncAudioReader.cpp AsyncAudioDecimator.cpp
           AsyncAudioInterpolator.cpp AsyncAudioDecoder.cpp
           AsyncAudioEncoder.cpp AsyncAudioEncoderS16.cpp
           AsyncAudioDecoderS16.cpp AsyncAudioEncoderGsm.cpp
           AsyncAudioDecoderGsm.cpp AsyncAudioRecorder.cpp
           AsyncAudioDeviceFactory.cpp AsyncAudioJitterFifo.cpp
           AsyncAudioDeviceUDP.cpp)

if(Speex_FOUND)
  set(LIBSRC ${LIBSRC} AsyncAudioEncoderSpeex.cpp AsyncAudioDecoderSpeex.cpp)
endif(Speex_FOUND)

if(Opus_FOUND)
  set(LIBSRC ${LIBSRC} AsyncAudioEncoderOpus.cpp AsyncAudioDecoderOpus.cpp)
endif(Opus_FOUND)

if(USE_ALSA)
  set(LIBSRC ${LIBSRC} AsyncAudioDeviceAlsa.cpp)
  find_package(ALSA REQUIRED)
  set(LIBS ${LIBS} ${ALSA_LIBRARIES})
  include_directories(${ALSA_INCLUDE_DIRS})
endif(USE_ALSA)

if(USE_OSS)
  set(LIBSRC ${LIBSRC} AsyncAudioDeviceOSS.cpp)
endif(USE_OSS)

set(LIBS ${LIBS} asynccore)

# Copy exported include files to the global include directory
foreach(incfile ${EXPINC})
  expinc(${incfile})
endforeach(incfile)

# Set up additional defines
add_definitions(-DT_LINUX)

# Build a shared library and a static library if configured
add_library(${LIBNAME} SHARED ${LIBSRC})
set_target_properties(${LIBNAME} PROPERTIES VERSION ${VER_LIBASYNC}
                      SOVERSION ${VER_LIBASYNC_SOVERSION})
target_link_libraries(${LIBNAME} ${LIBS})
if (BUILD_STATIC_LIBS)
  add_library(${LIBNAME}_static STATIC ${LIBSRC})
  set_target_properties(${LIBNAME}_static PROPERTIES OUTPUT_NAME ${LIBNAME})
  target_link_libraries(${LIBNAME}_static ${LIBS})
endif(BUILD_STATIC_LIBS)

# Install files
install(TARGETS ${LIBNAME} DESTINATION ${LIB_INSTALL_DIR})
if (BUILD_STATIC_LIBS)
  install(TARGETS ${LIBNAME}_static DESTINATION ${LIB_INSTALL_DIR})
endif(BUILD_STATIC_LIBS)
install(FILES ${EXPINC} DESTINATION ${SVX_INCLUDE_INSTALL_DIR})

=== src/async/core/CMakeLists.txt ===
set(LIBNAME asynccore)

set(EXPINC AsyncApplication.h AsyncFdWatch.h AsyncTimer.h AsyncIpAddress.h
           AsyncTcpClient.h AsyncDnsLookup.h AsyncUdpSocket.h AsyncTcpServer.h
           AsyncTcpConnection.h AsyncConfig.h AsyncSerial.h AsyncFileReader.h
           AsyncAtTimer.h AsyncExec.h)

set(LIBSRC AsyncApplication.cpp AsyncFdWatch.cpp AsyncTimer.cpp
           AsyncIpAddress.cpp AsyncDnsLookup.cpp AsyncTcpClient.cpp
           AsyncUdpSocket.cpp AsyncTcpServer.cpp
           AsyncTcpConnection.cpp AsyncConfig.cpp AsyncSerial.cpp
           AsyncSerialDevice.cpp AsyncFileReader.cpp
           AsyncAtTimer.cpp AsyncExec.cpp)

# Copy exported include files to the global include directory
foreach(incfile ${EXPINC})
  expinc(${incfile})
endforeach(incfile)

# Find pthreads
find_package(Threads)
set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})

# Set up additional defines
# FIXME: Do we need this?
add_definitions(-D_REENTRANT)

# Build a shared library and a static library if configured
add_library(${LIBNAME} SHARED ${LIBSRC})
set_target_properties(${LIBNAME} PROPERTIES VERSION ${VER_LIBASYNC}
                      SOVERSION ${VER_LIBASYNC_SOVERSION})
target_link_libraries(${LIBNAME} ${LIBS})
if (BUILD_STATIC_LIBS)
  add_library(${LIBNAME}_static STATIC ${LIBSRC})
  set_target_properties(${LIBNAME}_static PROPERTIES OUTPUT_NAME ${LIBNAME})
  target_link_libraries(${LIBNAME}_static ${LIBS})
endif(BUILD_STATIC_LIBS)

# Install files
install(TARGETS ${LIBNAME} DESTINATION ${LIB_INSTALL_DIR})
if (BUILD_STATIC_LIBS)
  install(TARGETS ${LIBNAME}_static DESTINATION ${LIB_INSTALL_DIR})
endif(BUILD_STATIC_LIBS)
install(FILES ${EXPINC} DESTINATION ${SVX_INCLUDE_INSTALL_DIR})

=== src/async/demo/CMakeLists.txt ===
set(CPPPROGS AsyncAudioIO_demo AsyncDnsLookup_demo AsyncFdWatch_demo
             AsyncTimer_demo AsyncTcpClient_demo AsyncUdpSocket_demo
             AsyncCppApplication_demo AsyncTcpServer_demo AsyncConfig_demo
             AsyncSerial_demo AsyncAtTimer_demo AsyncExec_demo)


foreach(prog ${CPPPROGS})
  add_executable(${prog} ${prog}.cpp)
  target_link_libraries(${prog} ${LIBS} asynccpp asyncaudio asynccore)
endforeach(prog)

if(USE_QT)
  # Find Qt4
  find_package(Qt4 4.2 REQUIRED QtCore QtGui QtNetwork)
  include(${QT_USE_FILE})
  set(LIBS ${LIBS} ${QT_LIBRARIES})
  #QT4_WRAP_CPP(QTHEADERS_MOC ${QTHEADERS})

  add_executable(AsyncQtApplication_demo AsyncQtApplication_demo.cpp)
  target_link_libraries(AsyncQtApplication_demo ${LIBS} asyncaudio
                        asynccore asyncqt)
endif(USE_QT)

=== src/async/qt/CMakeLists.txt ===
set(LIBNAME asyncqt)

set(EXPINC AsyncQtApplication.h)

set(LIBSRC AsyncQtApplication.cpp AsyncQtDnsLookupWorker.cpp)

set(QTHEADERS AsyncQtApplication.h AsyncQtTimer.h AsyncQtDnsLookupWorker.h)

set(LIBS ${LIBS} asynccore)

# Copy exported include files to the global include directory
foreach(incfile ${EXPINC})
  expinc(${incfile})
endforeach(incfile)

# Find Qt4
find_package(Qt4 4.2 REQUIRED QtCore QtGui QtNetwork)
include(${QT_USE_FILE})
set(LIBS ${LIBS} ${QT_LIBRARIES})
QT4_WRAP_CPP(QTHEADERS_MOC ${QTHEADERS})

# Build a shared library and a static library if configured
add_library(${LIBNAME} SHARED ${LIBSRC} ${QTHEADERS_MOC})
set_target_properties(${LIBNAME} PROPERTIES VERSION ${VER_LIBASYNC}
                      SOVERSION ${VER_LIBASYNC_SOVERSION})
target_link_libraries(${LIBNAME} ${LIBS})
if (BUILD_STATIC_LIBS)
  add_library(${LIBNAME}_static STATIC ${LIBSRC})
  set_target_properties(${LIBNAME}_static PROPERTIES OUTPUT_NAME ${LIBNAME})
  target_link_libraries(${LIBNAME}_static ${LIBS})
endif(BUILD_STATIC_LIBS)

# Install files
install(TARGETS ${LIBNAME} DESTINATION ${LIB_INSTALL_DIR})
if (BUILD_STATIC_LIBS)
  install(TARGETS ${LIBNAME}_static DESTINATION ${LIB_INSTALL_DIR})
endif(BUILD_STATIC_LIBS)
install(FILES ${EXPINC} DESTINATION ${SVX_INCLUDE_INSTALL_DIR})

## svxlink 14.08

=== debian/changelog ===
svxlink (14.08-1) unstable; urgency=low

  * Initial release (Closes: #733060)

 -- Felix Lechner <felix.lechner@gmail.com>  Tue, 21 Oct 2014 08:52:08 -0700

=== debian/control ===
Source: svxlink
Section: hamradio
Priority: optional
Maintainer: Felix Lechner <felix.lechner@gmail.com>
Build-Depends: debhelper (>= 9), quilt, cmake, doxygen,
 libsigc++-2.0-dev (>= 2.2.10-0.2), libpopt-dev, libgcrypt20-dev,
 libgsm1-dev, libspeex-dev, libopus-dev, libasound2-dev,
 libqt4-dev, tcl-dev, tk-dev
Standards-Version: 3.9.6
Homepage: http://www.svxlink.org
Vcs-Browser: https://github.com/sm0svx/svxlink
Vcs-Git: https://github.com/sm0svx/svxlink.git

Package: svxlink-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Recommends: remotetrx (= ${binary:Version})
Description: Voice-over-IP server for ham radio operators
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 svxlink-server is normally used together with the 'remotetrx'
 package, which allows the remote control of a radio transceiver.
 .
 For a client program implementing the EchoLink® protocol, please
 have a look at the 'qtel' package.
 .
 This package contains the SvxLink server.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: svxlink-server-dbg
Architecture: any
Section: debug
Priority: extra
Depends: svxlink-server (= ${binary:Version}), ${misc:Depends}
Description: Voice-over-IP server for ham radio operators (debug symbols)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 SvxLink is normally used together with the 'remotetrx' package,
 which allows the remote control of a radio transceiver.
 .
 For a client program implementing the EchoLink® protocol, please
 have a look at the 'qtel' package.
 .
 This package contains the debug symbols for the SvxLink server.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: remotetrx
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Recommends: svxlink-server (= ${binary:Version})
Description: Remote controller for radio transceivers
 RemoteTrx facilitates remote control of ham radio transceivers via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The RemoteTrx server provides remote control of a connected radio
 transceiver.
 .
 RemoteTrx is normally used together with the 'svxlink-server'
 package, which allows for world-wide access via the Internet.
 .
 This package contains the RemoteTrx remote control server.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: remotetrx-dbg
Architecture: any
Section: debug
Priority: extra
Depends: remotetrx (= ${binary:Version}), ${misc:Depends}
Description: Remote controller for radio transceivers (debug symbols)
 RemoteTrx facilitates remote control of ham radio transceivers via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The RemoteTrx server provides remote control of a connected radio
 transceiver.
 .
 RemoteTrx would normally be used together with the 'svxlink-server'
 package, which allows for world-wide access via the Internet.
 .
 This package contains the debugging symbols for RemoteTrx.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: qtel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Graphical client for the EchoLink® protocol
 Qtel is a graphical client program for the EchoLink® ham radio
 protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 By connecting into a server connected to a repeater, an operator
 can call into a local radio net via the Internet while traveling
 out of the area.
 .
 This package contains the graphical client application Qtel.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: qtel-dbg
Architecture: any
Section: debug
Priority: extra
Depends: qtel (= ${binary:Version}), ${misc:Depends}
Description: Graphical client for the EchoLink® protocol (debug symbols)
 Qtel is a graphical client program for the EchoLink® ham radio
 protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 By connecting into a server connected to a repeater, an operator
 can call into a local radio net via the Internet while traveling
 out of the area.
 .
 This package contains the debugging symbols for Qtel.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasynccpp1.3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AsyncCpp library for SvxLink
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains the AsyncCpp library.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasynccpp-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends}, libasynccpp1.3 (= ${binary:Version})
Description: AsyncCpp library for SvxLink (debug symbols)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains the debug symbols for the AsyncCpp library.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasynccpp-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, libasynccpp1.3 (= ${binary:Version})
Description: AsyncCpp library for SvxLink (development files)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains the static version and the header files for the
 AsyncCpp library.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasyncaudio1.3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AsyncAudio library for SvxLink
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains the AsyncAudio library.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasyncaudio-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends}, libasyncaudio1.3 (= ${binary:Version})
Description: AsyncAudio library for SvxLink (debug symbols)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains the debug symbols for the AsyncAudio library.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasyncaudio-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, libasyncaudio1.3 (= ${binary:Version})
Description: AsyncAudio library for SvxLink (development files)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains the static version and the header files for the
 AsyncAudio library.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libecholib1.3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: EchoLib library for SvxLink
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains EchoLib, a library for EchoLink communications.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libecholib-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends}, libecholib1.3 (= ${binary:Version})
Description: EchoLib library for SvxLink (debug symbols)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains the debug symbols for the EchoLib library.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libecholib-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, libecholib1.3 (= ${binary:Version})
Description: EchoLib library for SvxLink (development files)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains the static version and the header files for the
 EchoLib library.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasyncqt1.3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AsyncQt library for SvxLink
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# The other tricks didn't work
# See https://wiki.debian.org/Hardening#Notes_for_packages_using_CMake
export DEB_BUILD_HARDENING=1

%:
	dh $@ --parallel --buildsystem=cmake --sourcedirectory=src --builddirectory=build 

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	find .. -name 'moc_*' -execdir rm -fv '{}' \;
	find .. -name 'qrc_*' -execdir rm -fv '{}' \;
	dh_auto_clean

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip -psvxlink-server --dbg-package=svxlink-server-dbg
	dh_strip -premotetrx --dbg-package=remotetrx-dbg
	dh_strip -pqtel --dbg-package=qtel-dbg
	dh_strip -plibecholib1.3 --dbg-package=libecholib-dbg
	dh_strip -plibasynccore1.3 --dbg-package=libasynccore-dbg
	dh_strip -plibasynccpp1.3 --dbg-package=libasynccpp-dbg
	dh_strip -plibasyncaudio1.3 --dbg-package=libasyncaudio-dbg
	dh_strip -plibasyncqt1.3 --dbg-package=libasyncqt-dbg

.PHONY: override_dh_install_init
override_dh_installinit:
	dh_installinit -psvxlink-server --name=svxlink
	dh_installinit -premotetrx

.PHONY: override_dh_installchangelogs
override_dh_installchangelogs:
	dh_installchangelogs -psvxlink-server src/svxlink/ChangeLog
	dh_installchangelogs -psvxlink-server-dbg src/svxlink/ChangeLog
	dh_installchangelogs -premotetrx src/svxlink/ChangeLog
	dh_installchangelogs -premotetrx-dbg src/svxlink/ChangeLog
	dh_installchangelogs -pqtel src/qtel/ChangeLog
	dh_installchangelogs -pqtel-dbg src/qtel/ChangeLog
	dh_installchangelogs -plibecholib1.3 src/echolib/ChangeLog
	dh_installchangelogs -plibecholib-dev src/echolib/ChangeLog
	dh_installchangelogs -plibecholib-dbg src/echolib/ChangeLog
	dh_installchangelogs -plibasynccore1.3 src/async/ChangeLog
	dh_installchangelogs -plibasynccore-dev src/async/ChangeLog
	dh_installchangelogs -plibasynccore-dbg src/async/ChangeLog
	dh_installchangelogs -plibasyncaudio1.3 src/async/ChangeLog
	dh_installchangelogs -plibasyncaudio-dev src/async/ChangeLog
	dh_installchangelogs -plibasyncaudio-dbg src/async/ChangeLog
	dh_installchangelogs -plibasynccpp1.3 src/async/ChangeLog
	dh_installchangelogs -plibasynccpp-dev src/async/ChangeLog
	dh_installchangelogs -plibasynccpp-dbg src/async/ChangeLog
	dh_installchangelogs -plibasyncqt1.3 src/async/ChangeLog
	dh_installchangelogs -plibasyncqt-dev src/async/ChangeLog
	dh_installchangelogs -plibasyncqt-dbg src/async/ChangeLog

#.PHONY: override_dh_fixperms
#override_dh_fixperms:
#	dh_fixperms
#	chmod a-x debian/svxlink-server/etc/default/svxlink
#	chmod a-x debian/remotetrx/etc/default/remotetrx
